#include <stdlib.h>
#include <math.h>
#include <imsls.h>

int main()
{
  char *col_labels[] = {" ", "\nID", "\nDF", "\nSSQ", 
                        "Mean\nsquares", "\nF", "\np-value"};
  int i, page_width = 132;
  
  int n = 24;                /* Total number of observations */
  int n_locations = 1;       /* Number of locations */
  int n_whole = 2;           /* Number of Whole-plots within a location */
  int n_split = 4;           /* Number of Split-plots within a location, Whole_plot */
  int rep[]={
    1, 1, 1, 1, 1, 1, 1, 1,
    2, 2, 2, 2, 2, 2, 2, 2,
    3, 3, 3, 3, 3, 3, 3, 3};
  int whole[]={
    1, 1, 1, 1, 2, 2, 2, 2, 
    1, 1, 1, 1, 2, 2, 2, 2,
    1, 1, 1, 1, 2, 2, 2, 2};
  int split[]={
    1, 2, 3, 4, 1, 2, 3, 4, 
    1, 2, 3, 4, 1, 2, 3, 4,  
    1, 2, 3, 4, 1, 2, 3, 4};
  float y[] ={
    30.0, 40.0, 38.9, 38.2,
    41.8, 52.2, 54.8, 58.2,
    20.5, 26.9, 21.4, 25.1,
    26.4, 36.7, 28.9, 35.9,
    21.0, 25.4, 24.0, 23.3,
    34.4, 41.0, 33.0, 34.9};
  float grand_mean;
  float *aov;
  float *treatment_means;
  float *whole_plot_means;
  float *split_plot_means;
  int *equal_means;
  char **aov_row_labels;

  aov = imsls_f_split_plot(n, n_locations, n_whole, n_split, 
                           rep, whole, split, y, 
                           IMSLS_GRAND_MEAN, &grand_mean, 
                           IMSLS_TREATMENT_MEANS, &treatment_means, 
                           IMSLS_WHOLE_PLOT_MEANS, &whole_plot_means, 
                           IMSLS_SPLIT_PLOT_MEANS, &split_plot_means,
                           IMSLS_ANOVA_ROW_LABELS, &aov_row_labels,
                           0);
  
  /* Output results. */
  imsls_page(IMSLS_SET_PAGE_WIDTH, &page_width);

  /* Print ANOVA table, without first column. */
  imsls_f_write_matrix("   *** ANALYSIS OF VARIANCE TABLE ***", 
                       11, 6, aov, 
                       IMSLS_WRITE_FORMAT, "%3.0f%3.0f%8.2f%7.2f%7.2f%7.3f",
                       IMSLS_ROW_LABELS, aov_row_labels,
                       IMSLS_COL_LABELS, col_labels,
                       0);

  /* Print the various means. */
  printf("\n\nGrand mean: %f\n", grand_mean);
  imsls_f_write_matrix("Treatment Means", n_whole, n_split,
                       treatment_means, 0);
  imsls_f_write_matrix("Whole-plot  Means", n_whole, 1,
                       whole_plot_means, 0);
  imsls_f_write_matrix("Split-plot Means", n_split, 1,
                       split_plot_means, 0);

}

